//************************************************************************************
//**  
//**  File name:     F:\FLOWCODE_\PuchRul.c
//**  Generated by:  Flowcode v3.4.7.48
//**  Date:          Tuesday, December 09, 2008 13:19:10
//**  Licence:       Professional
//**  
//**        ***UNREGISTERED***
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_PIC

//Defines for microcontroller
#define P16F684
#define MX_EE
#define MX_EE_SIZE 256
#define MX_PWM
#define MX_PWM_CNT 1
#define MX_PWM_TRIS1 trisc
#define MX_PWM_1 5

//Functions
#include <system.h>
#pragma CLOCK_FREQ 4000000

//Configuration data

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode V3\FCD\internals.h"

//Macro function declarations
void FCM_Change();


//Variable declarations
char FCV_A;
char FCV_B;




//PWM0: //Macro function declarations

void FCD_PWM0_Enable(char nIdx);
void FCD_PWM0_Disable(char nIdx);
void FCD_PWM0_SetDutyCycle(char nIdx, char nDuty);
void FCD_PWM0_ChangePeriod(char nPeriodVal, char nPrescalerVal);


//ADC0: //Macro function declarations

void FCD_ADC0_SampleADC();
char FCD_ADC0_ReadAsByte();
short FCD_ADC0_ReadAsInt();

//Supplementary defines




//PWM0: //Macro implementations


void FCD_PWM0_Enable(char nIdx)
{
	
	  //error checking
	  #ifndef MX_PWM
	    #warning "This chip does not have PWM capability"
	  #else
	    #ifndef MX_PWM_CNT
	      #pragma error FCD file error (no MX_PWM_CNT)
	    #endif
	    #if (MX_PWM_CNT < 1)
	      #pragma error FCD file error (MX_PWM_CNT < 1)
	    #endif
	    #if (MX_PWM_CNT > 2)
	      #pragma error FCD file error (MX_PWM_CNT > 2)
	    #endif
	    #ifndef MX_PWM_TRIS1
	      #pragma error FCD file error (no MX_PWM_TRIS1)
	    #endif
	    #ifndef MX_PWM_1
	      #pragma error FCD file error (no MX_PWM_1)
	    #endif
	    #if (MX_PWM_CNT == 2)
	      #ifndef MX_PWM_TRIS2
	        #pragma error FCD file error (no MX_PWM_TRIS2)
	      #endif
	      #ifndef MX_PWM_2
	        #pragma error FCD file error (no MX_PWM_2)
	      #endif
	    #endif
	    #if (0 == 1)
	      #ifndef MX_PWM_TRIS1a
	        #pragma error PWM component error (using alternative, but no MX_PWM_TRIS1a)
	        #define MX_PWM_ALT_ERROR
	      #endif
	      #ifndef MX_PWM_1a
	        #pragma error PWM component error (using alternative, but no MX_PWM_1a)
	        #define MX_PWM_ALT_ERROR
	      #endif
	    #endif
	    #if (0 == 2)
	      #ifndef MX_PWM_TRIS2a
	        #pragma error PWM component error (using alternative, but no MX_PWM_TRIS2a)
	        #define MX_PWM_ALT_ERROR
	      #endif
	      #ifndef MX_PWM_2a
	        #pragma error PWM component error (using alternative, but no MX_PWM_2a)
	        #define MX_PWM_ALT_ERROR
	      #endif
	    #endif
	  #endif

	 #ifdef MX_PWM
	    pr2 = 255;
	    t2con = 0x04;

	  #if (MX_PWM_CNT >= 1)
	    if (nIdx == 1)
	    {
	        ccp1con = 0x0C;

	      #if (0 == 1)
	       #ifndef MX_PWM_ALT_ERROR
	        clear_bit(MX_PWM_TRIS1a, MX_PWM_1a);
	       #endif
	      #else
	        clear_bit(MX_PWM_TRIS1, MX_PWM_1);
	      #endif
		}
	  #endif

	  #if (MX_PWM_CNT >= 2)
	    if (nIdx == 2)
	    {
	        ccp2con = 0x0C;
	      #if (0 == 2)
	       #ifndef MX_PWM_ALT_ERROR
	        clear_bit(MX_PWM_TRIS2a, MX_PWM_2a);
	       #endif
	      #else
	        clear_bit(MX_PWM_TRIS2, MX_PWM_2);
	      #endif
	   }
	  #endif
	 #endif

	 #ifdef MX_PWM_ALT_ERROR
	   #undef MX_PWM_ALT_ERROR
	 #endif

}

void FCD_PWM0_Disable(char nIdx)
{
	
	  //error checking
	  #ifndef MX_PWM
	    #warning "This chip does not have PWM capability"
	  #endif

	 #ifdef MX_PWM
	  #if (MX_PWM_CNT >= 1)
	    if (nIdx == 1)
	    {
	        ccp1con = 0x00;
	    }
	  #endif

	  #if (MX_PWM_CNT >= 2)
	    if (nIdx == 2)
	    {
	        ccp2con = 0x00;
	    }
	  #endif
	 #endif

}

void FCD_PWM0_SetDutyCycle(char nIdx, char nDuty)
{
	
	  //error checking
	  #ifndef MX_PWM
	    #warning "This chip does not have PWM capability"
	  #endif

	 #ifdef MX_PWM
	  #if (MX_PWM_CNT >= 1)
	    if (nIdx == 1)
	    {
	        ccpr1l = nDuty;
	    }
	  #endif

	  #if (MX_PWM_CNT >= 2)
	    if (nIdx == 2)
	    {
	        ccpr2l = nDuty;
	    }
	  #endif
	 #endif

}

void FCD_PWM0_ChangePeriod(char nPeriodVal, char nPrescalerVal)
{
	
	  //error checking
	  #ifndef MX_PWM
	    #warning "This chip does not have PWM capability"
	  #endif

	  #ifdef MX_PWM
	    pr2 = nPeriodVal;

	    switch (nPrescalerVal)
	    {
	        case 1:
	            t2con = 0x04;
	            break;

	        case 4:
	            t2con = 0x05;
	            break;

	        case 16:
	            t2con = 0x06;
	            break;
	    }
	  #endif

}



//ADC0: //Macro implementations


void FCD_ADC0_SampleADC()
{
	//This is from the FCD file...
	//set up ADC conversion
	char old_tris, cnt;
	#define MX_ADC_SAMP_TIME 40
	adcon1 = 0x20;

	//find appropriate bit
	#if (0 == 0)
	  #define MX_ADC_TRIS_REG  trisa
	  #define MX_ADC_TRIS_MSK  0x01
	  ansel = 0x01;
	#endif
	#if (0 == 1)
	  #define MX_ADC_TRIS_REG  trisa
	  #define MX_ADC_TRIS_MSK  0x02
	  ansel = 0x02;
	#endif
	#if (0 == 2)
	  #define MX_ADC_TRIS_REG  trisa
	  #define MX_ADC_TRIS_MSK  0x04
	  ansel = 0x04;
	#endif
	#if (0 == 3)
	  #define MX_ADC_TRIS_REG  trisa
	  #define MX_ADC_TRIS_MSK  0x10
	  ansel = 0x08;
	#endif
	#if (0 == 4)
	  #define MX_ADC_TRIS_REG  trisc
	  #define MX_ADC_TRIS_MSK  0x01
	  ansel = 0x10;
	#endif
	#if (0 == 5)
	  #define MX_ADC_TRIS_REG  trisc
	  #define MX_ADC_TRIS_MSK  0x02
	  ansel = 0x20;
	#endif
	#if (0 == 6)
	  #define MX_ADC_TRIS_REG  trisc
	  #define MX_ADC_TRIS_MSK  0x04
	  ansel = 0x40;
	#endif
	#if (0 == 7)
	  #define MX_ADC_TRIS_REG  trisc
	  #define MX_ADC_TRIS_MSK  0x08
	  ansel = 0x80;
	#endif

	//sanity check
	#ifndef MX_ADC_TRIS_REG
	  #pragma error ADC conversion code error - please contact technical support
	#endif
	 
	//store old tris value, and set the i/o pin as an input
	old_tris = MX_ADC_TRIS_REG;
	MX_ADC_TRIS_REG = MX_ADC_TRIS_REG | MX_ADC_TRIS_MSK;
	 
	//turn ADC on
	adcon0 = 0x01 | (0 << 2);

	//wait the acquisition time
	cnt = 0;
	while (cnt < MX_ADC_SAMP_TIME) cnt++;
	 
	//begin conversion and wait until it has finished
	adcon0 = adcon0 | 0x02;
	while (adcon0 & 0x02);

	//restore old tris value, and reset adc registers
	MX_ADC_TRIS_REG = old_tris;
	ansel = 0x00;
	adcon0 = 0x00;
	#undef MX_ADC_TRIS_REG
	#undef MX_ADC_TRIS_MSK
	#undef MX_ADC_SAMP_TIME

}

char FCD_ADC0_ReadAsByte()
{
	//This is from the FCD file...
	return adresh;

}

short FCD_ADC0_ReadAsInt()
{
	//This is from the FCD file...
	short iRetVal;
	iRetVal = (adresh << 2);
	iRetVal += (adresl >> 6);
	return (iRetVal);

}

//Macro implementations

void FCM_Change()
{
	
	//Calculation
	//Calculation:
	//  A = 1
	FCV_A = 1;
	

}

//Supplementary implementations


void main()
{
	
	//Initialisation
	ansel = 0x00;
cmcon0 = 0x07;


	//Interrupt initialisation code
	option_reg = 0xC0;


	//C Code
	//C Code:
	osccon = 0X74;
	cmcon0 = 0X07;


	//Interrupt
	//Interrupt: Enable RB0/INT
	option_reg.INTEDG=0;
	intcon.GIE=1;
	intcon.INTE=1;


	//Call Component Macro
	//Call Component Macro: PWM(0)::Enable(1)
	FCD_PWM0_Enable(1);


	//Loop
	//Loop: While 1
	while (1)
	{
		//Call Component Macro
		//Call Component Macro: ADC(0)::SampleADC
		FCD_ADC0_SampleADC();


		//Call Component Macro
		//Call Component Macro: B=ADC(0)::ReadAsByte
		FCV_B = FCD_ADC0_ReadAsByte();


		//Call Component Macro
		//Call Component Macro: PWM(0)::SetDutyCycle(1, B)
		FCD_PWM0_SetDutyCycle(1, FCV_B);


		//Decision
		//Decision: A > 0?
		if (FCV_A > 0)
		{
			//Calculation
			//Calculation:
			//  A = 0
			FCV_A = 0;
			

			//Output
			//Output: 1 -> C4
			trisc = trisc & 0xef;
			if (1)
				portc = (portc & 0xef) | 0x10;
			else
				portc = portc & 0xef;


		} else {
			//Output
			//Output: 0 -> PORT C
			trisc = 0x00;
			portc = 0;


		}


	}


	mainendloop: goto mainendloop;
}

void interrupt(void)
{
	if (intcon & (1 << INTF))
	{
		FCM_Change();
		clear_bit(intcon, INTF);
	}


}



